// Time-stamp: </wrf/c/connect/bit2char.cc, Sun, 27 May 2007, 18:55:36 EDT, http://wrfranklin.org/>
//
// Unpack the concrete data from 1 pixel per bit up to 1 per byte.
// Write the output as a char, '0' or '1'.
// 
// Read from cin, write to cout
// 
// Possible portability problems:
// 1. endianness.  Redefine mask to change this.
// 2. binary output to cout.
//
// WRF

#include <iostream>
#include <stdlib.h>

using namespace std;

main()
{
  char a;  // input pixel 
  int i,n;
  char mask[8]={128,64,32,16,8,4,2,1};  // Where each bit is.

  cin.unsetf(ios::skipws);    // Do not skip spaces on input.
  for(n=0;cin>>a;n++)
    {
      if (cin.eof()) 
	{
	  cerr << "unpack cin hit eof, # bytes read=" << n << endl;
	  break;
	}
      if (cin.fail()) 
	{
	  cerr << "unpack cin failed, # bytes read=" << n << endl;
	  exit(1);
	}
      for(i=0;i<8;i++)
	cout << ((a&mask[i])?'1':'0');
    }
  cerr << "bit2char finished, # bytes=" << n << endl;
}

