// Time-stamp: </wrf/c/connect/char2bit.cc, Sun, 27 May 2007, 18:52:35 EDT, http://wrfranklin.org/>
//
// Pack the concrete data from 1 pixel per byte down to 1 per bit.
// The input data is char '0' or '1'.
// 
// Read from cin, write to cout
//
// Ignores whitespace.
// 
// Possible portability problems:
// 1. endianness.  Redefine mask to change this.
// 2. binary output to cout.
//
// The input need not be a multiple of 8 bytes long.
//
// WRF

#include <iostream>

using namespace std;

main()
{
  char a;  // input pixel 
  char b;     // output pixel
  int i,n;
  char mask[8]={128,64,32,16,8,4,2,1};  // Where each bit should go.

  for(n=0;;)
    {
      b=0;
      for(i=0;(i<8 && cin>>a);i++)
	{
	  n++;
	  if (cin.fail())
	{
	  cerr << "char2bit cin failed, # bytes read=" << n << endl;
	  exit(1);
	}

	  // The '-' converts a 0x1 result of the '!=' into a mask of all ones.
	  b |= ((-(a!='0'))&mask[i]);
	}
      if (i>0) cout<<b;  // Write out the last byte if it has at least one bit.
      if (i<8) break;
    }
  cerr << "char2bit packed " << n << " voxels." << endl;
}

