// Time-stamp: </wrf/c/connect/char2pbm.cc, Sun, 27 May 2007, 18:54:55 EDT, http://wrfranklin.org/>

// Usage:  char2pbm nx ny nz goodx < ascvol > pbmfile
// cin is  a nx by ny by nz volume of  0s and 1s.
// Extract plane #goodx into a pbm file as cout.


#include <iostream>
#include <stdlib.h>

using namespace std;

int nx;
int ny;
int nz;

void die(const char *msg)
{	std::cerr << "ERROR: " << msg << endl;
 exit(1);
}

main(const int argc, const char **const argv) 
{
  int ix, iy, iz, goodx, nbytes=0;
  char c;

  cin.unsetf(ios::skipws);    // Do not skip spaces on input.

  if (argc!=5) {
    cerr << "argc=" << argc << endl;
    die("Usage: char2pbm ROWTOEXTRACT < ascfil > pbmfile");
  }
  nx = atoi(argv[1]);
  ny = atoi(argv[2]);
  nz = atoi(argv[3]);
  goodx = atoi(argv[4]);

  cerr << "CHAR2PBM: nx=" << nx << ", ny=" << ny << ", nz=" << nz 
       << ", goodx=" << goodx << endl;
  cout << "P1" << endl;
  cout << "# Plane " << goodx << endl;
  cout << nz << ' ' << ny << endl;  
  for (ix=0; ix<nx; ix++)
    for (iy=0; iy<ny; iy++)
      for (iz=0; iz<nz; iz++) {
	nbytes++;
	cin >> c;
	if (cin.eof()) {
	  cerr << "char2pbm cin hit eof, # bytes read=" << nbytes << endl;
	  break;
	}
	if (cin.fail()) {
	  cerr << "char2pbm cin failed, # bytes read=" << nbytes << endl;
	  exit(1);
	}
	if (ix == goodx) cout << c;
      }
  cout << endl;
}
