// Time-stamp: </wrf/c/connect/rotateyzx2.cc, Tue, 12 Nov 2002, 12:34:56 EST, wrf@benvolio.ecse.rpi.edu>

// Rotate around the grand diagonal the standard input, assumed to be
// a 544x544x512 array of bits.  On input, the dimensions are ordered
// X,Y,Z.  On output, they are ordered Y,Z,X. This version uses one
// bit per voxel, to save space at the expense of time.

// Typical use:  
// gunzip < file1.gz | bit2char | rotatexyz | char2bit | gzip -v > file2.gz

#include <iostream>

using namespace std;

const int nx=544;
const int ny=544;
const int nz=512;
const int nbits=nx*ny*nz;          // Total number of bits.
const int nchars=(nbits+7)/8;           // Total number of chars.

char universe[nchars];

char mask[8]={128,64,32,16,8,4,2,1};  // Where each bit should go.

main()
{
  int x,y,z;
  int ib, ic;
  int k, kb, kc;
  int voxel;
  char outchar = 0;
  int iob = 0;

  cin.unsetf(ios::skipws);    // Do not skip spaces on input.

  for (ic=0; ic<nchars; ic++) {
    cin >> universe[ic];
    if (cin.eof()) 
      { cerr << "Rotatexyz: cin eof" << endl;
      cerr << "ic=" << ic << endl;
      goto L;
      }
    if (cin.fail()) 
      { cerr << "Rotatexyz: cin fail" << endl;
      cerr << "ic=" << ic << endl;
      goto L;
      }
  }

  cerr << "Rotatexyz2 finished reading.  nbits=" << nbits << endl;

  for (ib=0; ib<nbits; ib++) {
    if (ib%10000000==0) cerr << "ib=" << ib << endl;
    y = ib/(nx*nz);
    z = ib/nx%nz;
    x = ib%nx;

    k = x*(ny*nz)+y*nz+z;
    kc = k/8;
    kb = k%8;

    voxel = (universe[kc] & mask[kb]) ? -1 : 0;
    outchar |= voxel&mask[iob++];

    if (iob>=8) {
      cout << outchar;	
      if (cout.fail()) {
	cerr << "Rotatexyz: cout fail at x=" << x << ", y=" << y 
	     << ", z=" << z << endl;
	goto L;
      }
      iob = 0;
      outchar = 0;
    }
  }
  if (iob>0) cout << outchar;

 L:;
}
